/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM calIPrintFormatter.idl
 */

#ifndef __gen_calIPrintFormatter_h__
#define __gen_calIPrintFormatter_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class calIItemBase; /* forward declaration */

class calIDateTime; /* forward declaration */

class nsIOutputStream; /* forward declaration */


/* starting interface:    calIPrintFormatter */
#define CALIPRINTFORMATTER_IID_STR "014dea21-90cd-4563-b1bd-13b842a465e0"

#define CALIPRINTFORMATTER_IID \
  {0x014dea21, 0x90cd, 0x4563, \
    { 0xb1, 0xbd, 0x13, 0xb8, 0x42, 0xa4, 0x65, 0xe0 }}

class NS_NO_VTABLE calIPrintFormatter : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(CALIPRINTFORMATTER_IID)

  /**
   * The name of this layout. Implementers should make sure this string
   * is localizable, ie uses nsIStringBundle
   */
  /* readonly attribute AString name; */
  NS_IMETHOD GetName(nsAString & aName) = 0;

  /**
   * Format the items into the stream, as html code.
   * May assume that all the items are inside the given daterange.
   * The user requested to show all the days in the daterange, so unless
   * there is a special reason, all the days should be shown.
   * aStart and aEnd may be null, in which case the implementation can
   * show the minimal days needed to show all the events. It can skip
   * months without events, for example.
   *
   * @param aStream  the stream to put the html data into
   * @param aStart   the first date that should be printed
   * @param aEnd     the last date that should be printed
   * @param aCount   the number of items being printed
   * @param aItems   the items to print
   * @param aTitle   a title for the HTML page
   */
  /* void formatToHtml (in nsIOutputStream aStream, in calIDateTime aStart, in calIDateTime aEnd, in unsigned long aCount, [array, size_is (aCount)] in calIItemBase aItems, in AString aTitle); */
  NS_IMETHOD FormatToHtml(nsIOutputStream *aStream, calIDateTime *aStart, calIDateTime *aEnd, PRUint32 aCount, calIItemBase **aItems, const nsAString & aTitle) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_CALIPRINTFORMATTER \
  NS_IMETHOD GetName(nsAString & aName); \
  NS_IMETHOD FormatToHtml(nsIOutputStream *aStream, calIDateTime *aStart, calIDateTime *aEnd, PRUint32 aCount, calIItemBase **aItems, const nsAString & aTitle); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_CALIPRINTFORMATTER(_to) \
  NS_IMETHOD GetName(nsAString & aName) { return _to GetName(aName); } \
  NS_IMETHOD FormatToHtml(nsIOutputStream *aStream, calIDateTime *aStart, calIDateTime *aEnd, PRUint32 aCount, calIItemBase **aItems, const nsAString & aTitle) { return _to FormatToHtml(aStream, aStart, aEnd, aCount, aItems, aTitle); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_CALIPRINTFORMATTER(_to) \
  NS_IMETHOD GetName(nsAString & aName) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetName(aName); } \
  NS_IMETHOD FormatToHtml(nsIOutputStream *aStream, calIDateTime *aStart, calIDateTime *aEnd, PRUint32 aCount, calIItemBase **aItems, const nsAString & aTitle) { return !_to ? NS_ERROR_NULL_POINTER : _to->FormatToHtml(aStream, aStart, aEnd, aCount, aItems, aTitle); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public calIPrintFormatter
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_CALIPRINTFORMATTER

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, calIPrintFormatter)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* readonly attribute AString name; */
NS_IMETHODIMP _MYCLASS_::GetName(nsAString & aName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void formatToHtml (in nsIOutputStream aStream, in calIDateTime aStart, in calIDateTime aEnd, in unsigned long aCount, [array, size_is (aCount)] in calIItemBase aItems, in AString aTitle); */
NS_IMETHODIMP _MYCLASS_::FormatToHtml(nsIOutputStream *aStream, calIDateTime *aStart, calIDateTime *aEnd, PRUint32 aCount, calIItemBase **aItems, const nsAString & aTitle)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_calIPrintFormatter_h__ */
